<?php
class Bootstrap extends Zend_Application_Bootstrap_Bootstrap{

    protected function _initRoutes(){
        $this->bootstrap('FrontController');
        $front = $this->getResource('FrontController');
        
        $router = $front->getRouter();
        $router->addRoute('error404', new Zend_Controller_Router_Route('404', array('controller' => 'error', 'action'=> 'error404')));
        $router->addRoute('error403', new Zend_Controller_Router_Route('403', array('controller' => 'error', 'action'=> 'error403')));
    }
    
    protected function _initHelperPath(){
        Zend_Controller_Action_HelperBroker::addPath(APPLICATION_PATH . '/controllers/helpers', 'Application_Controller_Action_Helper_');
    }
    
    protected function _initCoreSession(){
        $this->bootstrap('db');
        $this->bootstrap('session');

        try {
            Zend_Session::start();
        } catch(Zend_Session_Exception $e) {
            Zend_Session::regenerateId(false);
            Zend_Session::destroy(true);
        }
        
        Zend_Session::registerValidator(new Zend_Session_Validator_HttpUserAgent());
    }
    
    protected function _initView(){
        $view = new Zend_View();
        $view->doctype('XHTML1_STRICT');
        $view->headTitle('AMF Auth');
        $view->env = APPLICATION_ENV;

        $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer');
        $viewRenderer->setView($view);

        return $view;
    }
}
