<?php

Zend_Loader::loadClass("LoginService", APPLICATION_PATH.'/controllers/amf/services');
Zend_Loader::loadClass("LoginVO", APPLICATION_PATH.'/controllers/amf/vo');
Zend_Loader::loadClass("UserVO", APPLICATION_PATH.'/controllers/amf/vo');
	
class AmfController extends Zend_Controller_Action{
	
	public function init(){
		$this->_helper->layout()->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
	}
		
	public function indexAction() {
		$server = new Zend_Amf_Server();

		$server->setSession();
		$server->setProduction(false);
		$server->setAcl($this->_initAcl());
		
		$server->setClass("LoginVO");
		$server->setClass("UserVO");
		$server->setClass("LoginService");
		
		$server->setClassMap("LoginVO","LoginVO");
		$server->setClassMap("UserVO","UserVO");

		echo $server->handle();
	}
	
	private function _initAcl(){
		$acl = new Zend_Acl();
	    
		$acl->addRole(new Zend_Acl_Role('Guest'));
		$acl->addRole(new Zend_Acl_Role('User'),'Guest');
		$acl->addRole(new Zend_Acl_Role('Moderator'), 'User');
		$acl->addRole(new Zend_Acl_Role('Administrator'), 'Moderator');
	    
		$acl->addResource(new Zend_Acl_Resource('LoginService'));
		$acl->allow('Guest','LoginService',array('getToken','login','logoutService','isLogged'));
		$acl->allow('Administrator');
		
		return $acl;
	}
}
